#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include "st-accel.h"

int fd;

void handleExit(int signum)
{
	printf("Powering down accelerometer...\n");
	ioctl(fd, ACCEL_POWER_OFF);
	exit(0);
}

int main(int argc, char *argv[])
{
	int count, i;
	unsigned char buf[16348];
	unsigned char oldbuf[16348];

	fd = open("/dev/st-accel", O_RDWR);
	if (fd < 0)
		return -1;

	signal(SIGINT, handleExit);

	ioctl(fd, ACCEL_SET_RATE, RATE_280HZ);
	ioctl(fd, ACCEL_POWER_ON);

	for (;;) {
		count = read(fd, buf, 16384);
		if (count < 0)
			printf("Error: %d\n", count);

		for (i = 0; i < count; i++) {
			if (i + 13 <= count && buf[i] == 0xa5 && buf[i + 1] == 0xa5) {
				printf("Measurement: status = %02x, x = %d, y = %d, z = %d\n",
					buf[i + 2], (short)(buf[i + 3] | (buf[i + 4] << 8)),
					(short)(buf[i + 5] | (buf[i + 6] << 8)),
					(short)(buf[i + 7] | (buf[i + 8] << 8)));

				i += 2;
				if (buf[i + 2] & X_AXIS)
					i += 2;
				if (buf[i + 2] & Y_AXIS)
					i += 2;
				if (buf[i + 2] & Z_AXIS)
					i += 2;
			}
		}
	}
}
